use std::io::{stdin,stdout,Write};
use std::process::{Command};

// Declare the modules from these files
mod parse_map; // parse_map.rs
mod output_map; // output_map.rs

const HELP_STRING: &str = "'help' = output's this help text
'travel' = travel to a given location
";

struct Coordinates {
	x: i16,
//	y: i16,
	z: i16,
}

fn clear_screen()
{
	Command::new("clear")
		.status()
		.expect("Failed to clear screen");
}
fn input() -> String{
    let mut s=String::new();
    let _=stdout().flush();
    stdin().read_line(&mut s).expect("Did not enter a correct string");
    if let Some('\n')=s.chars().next_back() {
        s.pop();
    }
    if let Some('\r')=s.chars().next_back() {
        s.pop();
    }
    return s;
}


fn main() 
{
	let debug_mode = true;
	let (screen_width, screen_height) = termion::terminal_size().unwrap();
	let distance_you_can_see: [i16; 2] = 
	[
		(screen_width as f32 / 2.0) as i16, 
		(screen_height as f32 / 2.0) as i16
	];
	if debug_mode 
	{
		println!("Screen Width: {}, Screen Height: {}", screen_width, screen_height);
	}

	// Player data
	let map: &str = "world";
	let player_coordinates: Coordinates = Coordinates 
	{
		x: 30,
		//y: 1,
		z: 30,
	};

	if let Ok((ground_map, above_map)) = parse_map::parse_map(map) // Call the parse map function from parse_map.rs 
	{ // Parse the map file into a vector
		output_map::output_map // Call output_map fuctino from output_map.rs
		(
			&ground_map, 
			&above_map, 
			&player_coordinates, 
			&distance_you_can_see
		); // Output the map
		'game_loop: loop 
		{
			if ! debug_mode 
			{
				clear_screen()
			}
			print!("> ");
			let user_input: String = input();
			if user_input == "help"
			{
				print!("\n{}\n", HELP_STRING);
			}
			else if user_input == "exit"
			{
				// TO DO: SAVE	
				print!("Exiting...\n");
				break 'game_loop;
			}
		}
	}
	else 
	{
		eprintln!("Error parsing map files.");
	}
}
